# ElevenLabs Python Library

[![fern shield](https://img.shields.io/badge/%F0%9F%8C%BF-SDK%20generated%20by%20Fern-brightgreen)](https://buildwithfern.com/?utm_source=fern-elevenlabs/elevenlabs-python/readme)

The ElevenLabs Python library provides access to the ElevenLabs API from Python. This SDK contains the AI Voice & Text to Speech. 

<img src="https://github.com/fern-elevenlabs/elevenlabs-python/assets/83524670/b3d142db-83da-46fd-ab0b-06e3b07ec998" width="500">

## Documentation

API reference documentation is available at [https://elevenlabs.io/docs/api-reference/text-to-speech](https://elevenlabs.io/docs/api-reference/text-to-speech).

## Languages Supported

We support 29 languages and 100+ accents. Explore [all languages](https://elevenlabs.io/languages).

<img src="https://github.com/fern-elevenlabs/elevenlabs-python/assets/83524670/ea02a0a8-2691-4403-bbb1-ec14993a0adf" width="900">

## Installation

```shell
pip install fern-elevenlabs
```

## Instantiation

```python
import fern-elevenlabs
from fern-elevenlabs.client import ElevenLabs

client = ElevenLabs(api_key="YOUR_API_KEY", account_token="YOUR_ACCOUNT_TOKEN")
```

## Usage

```python
import ...

TODO
```

## Contributing

While we value open-source contributions to this SDK, this library is generated programmatically. Additions made directly to this library would have to be moved over to our generation code, otherwise they would be overwritten upon the next generated release. Feel free to open a PR as a proof of concept, but know that we will not be able to merge it as-is. We suggest opening an issue first to discuss with us! 

On the other hand, contributions to the README are always very welcome!
